chiark / gitweb /
regress: Move case-*.in opening to shlib playback_prepare
[adns.git] / regress / r1test
index 4d10101bed755283158c74da2f6bf0e5b473fd2a..7d5a4d8b9a00f3d292e55880453ed6af55f03a01 100755 (executable)
@@ -1,24 +1,58 @@
 #!/bin/sh
 # usage: r1test <testcasename>
+# test execution script, for running one test
+#
+#  This file is part of adns, which is
+#    Copyright (C) 1997-2000,2003,2006,2014-2016,2020  Ian Jackson
+#    Copyright (C) 2014  Mark Wooding
+#    Copyright (C) 1999-2000,2003,2006  Tony Finch
+#    Copyright (C) 1991 Massachusetts Institute of Technology
+#  (See the file INSTALL for full details.)
+#  
+#  This program is free software; you can redistribute it and/or modify
+#  it under the terms of the GNU General Public License as published by
+#  the Free Software Foundation; either version 3, or (at your option)
+#  any later version.
+#  
+#  This program is distributed in the hope that it will be useful,
+#  but WITHOUT ANY WARRANTY; without even the implied warranty of
+#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#  GNU General Public License for more details.
+#  
+#  You should have received a copy of the GNU General Public License
+#  along with this program; if not, write to the Free Software Foundation.
 
 set -e
-casename="$1"
-case="case-$casename"
-ocase="output-$casename"
+: ${srcdir=.}
+. "$srcdir"/shlib
+mrc=1
+trap 'exit $mrc' 0
 
-exec <"$case.sys"
-read initfile initflags
-read queryargs
+casename="$1"
 
-initstring="`cat init-$initfile.text`"
+playback_prepare
 
 rm -f $ocase.*
 
-set +e
-ADNS_TEST_REPORT_FD=3 3>>"$ocase.report" >"$ocase.out" 2>"$ocase.err" \
- ./hplayback $initflags "/$initstring" $queryargs
-rc=$?
-set -e
+EF_DISABLE_BANNER=1
+export EF_DISABLE_BANNER
+
+if test ! -e $playback
+then
+       printf "SKIPPED-$casename "
+       mrc=5
+       exit
+fi
+
+playback_execute_hook () { :; }
+playback_execute
+
+if [ "$rc" = 5 ]
+then
+       printf "SKIPPED-$casename "
+       mrc=5
+       exit
+fi
 
 echo "rc=$rc" >>$ocase.out
 
@@ -29,16 +63,23 @@ do
        then
                :
        else
-               failed=true
+               failwhy="$failwhy WRONG OUTPUT"
        fi
 done
 
-if $failed
+cat <&4 >"$ocase.leftover"
+if egrep . /dev/null "$ocase.leftover"
 then
-       echo >&2 "FAILED $case - WRONG OUTPUT - lines of syscall remaining `wc -l`"
-       exit 2
+       failwhy="$failwhy EXITED EARLY"
 fi
 
-echo -n "$casename "
+if [ "x$failwhy" != x ]
+then
+       scremain="`wc -l <\"$ocase.leftover\"`"
+       echo >&2 "FAILED $case -$failwhy - lines of syscall remaining $scremain"
+       mrc=2
+       exit
+fi
 
-exit 0
+printf "$casename "
+mrc=0